/*	$NetBSD: esp_isa.c,v 1.6 1997/10/20 18:43:09 thorpej Exp $	*/
/* $Id: esp_pccard.c,v 1.4 2000/01/04 18:01:36 furuta Exp $ */

/*-
 * Copyright (c) 1997 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Jason R. Thorpe of the Numerical Aerospace Simulation Facility,
 * NASA Ames Research Center.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the NetBSD
 *	Foundation, Inc. and its contributors.
 * 4. Neither the name of The NetBSD Foundation nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Copyright (c) 1994 Peter Galbavy
 * Copyright (c) 1995 Paul Kranenburg
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Peter Galbavy
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Based on aic6360 by Jarle Greipsland
 *
 * Acknowledgements: Many of the algorithms used in this driver are
 * inspired by the work of Julian Elischer (julian@tfs.com) and
 * Charles Hannum (mycroft@duality.gnu.ai.mit.edu).  Thanks a million!
 */

/*
 * Initial m68k mac support from Allen Briggs <briggs@macbsd.com>
 * (basically consisting of the match, a bit of the attach, and the
 *  "DMA" glue functions).
 */
/*
 * Copyright (c) 1994, 1996, 1997 Charles M. Hannum.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Charles M. Hannum.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * Copyright (c) 1997 Eric S. Hvozda (hvozda@netcom.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Eric S. Hvozda.
 * 4. The name of Eric S. Hvozda may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*-
 * Copyright (c) 1999 NAKAGAWA, Yoshihisa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifdef __FreeBSD__
#define CAM

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/malloc.h>
#include <sys/buf.h>
#include <sys/queue.h>

#include <machine/bus_pio.h>
#include <machine/bus.h>

#ifdef CAM
#include <cam/cam.h>
#include <cam/cam_ccb.h>
#include <cam/cam_sim.h>
#include <cam/cam_xpt_sim.h>
#include <cam/cam_debug.h>

#include <cam/scsi/scsi_all.h>
#include <cam/scsi/scsi_message.h>
#else
#include <scsi/scsi_all.h>
#include <scsi/scsiconf.h>
#include <scsi/scsi_message.h>
#endif /* !CAM */

#include <dev/esp/ncr53c9xreg.h>
#include <dev/esp/ncr53c9xvar.h>

#include <i386/isa/isa_device.h> /* XXX should be removed */
#include <sys/select.h>
#include <pccard/cardinfo.h>
#include <pccard/slot.h>

#else
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/device.h>
#include <sys/buf.h>

#include <machine/bus.h>
#include <machine/intr.h>

#include <dev/scsipi/scsi_all.h>
#include <dev/scsipi/scsipi_all.h>
#include <dev/scsipi/scsiconf.h>
#include <dev/scsipi/scsi_message.h>

#include <dev/ic/ncr53c9xreg.h>
#include <dev/ic/ncr53c9xvar.h>
#endif

#include "esp.h"

struct esp_pccard_softc {
	struct ncr53c9x_softc	sc_ncr53c9x;	/* glue to MI code */

	int sc_active;		/* Pseudo-DMA state vars */
	int sc_tc;
	int sc_datain;
	size_t sc_dmasize;
	size_t sc_dmatrans;
	char **sc_dmaaddr;
	size_t *sc_pdmalen;

#ifndef __FreeBSD__
	int sc_port;
#endif
	bus_space_tag_t sc_iot;
	bus_space_handle_t sc_ioh;
	void *sc_ih;

	int sc_unit;
	int sc_enable;

#ifdef ESP_DEBUG
	int sc_debug;
#endif

	int sc_cfg4;
	int sc_cfg5;
};

struct esp_probe_data {
#ifndef __FreeBSD__
	struct device sc_dev;
#endif
	int sc_irq;
	int sc_rev;
	int sc_isfast;
	int sc_msize;
	int sc_parity;
	int sc_sync;
	int sc_id;
};

#define ESP_ISA_IOSIZE  16

#define ESP_DEBUG

#ifdef ESP_DEBUG

#define ESP_SHOWTRAC    0x01
#define ESP_SHOWREGS    0x02
#define ESP_SHOWMISC    0x04

#if 0
int esp_debug = 0; 	/* ESP_SHOWTRAC | ESP_SHOWREGS | ESP_SHOWMISC */
#else
int esp_debug = ESP_SHOWTRAC | ESP_SHOWREGS | ESP_SHOWMISC;
#endif

#define ESP_TRACE(str)  \
        do {if (esp_debug & ESP_SHOWTRAC) printf str;} while (0)
#define ESP_REGS(str)  \
        do {if (esp_debug & ESP_SHOWREGS) printf str;} while (0)
#define ESP_MISC(str)  \
        do {if (esp_debug & ESP_SHOWMISC) printf str;} while (0)
#else
#define ESP_TRACE(str)
#define ESP_REGS(str)
#define ESP_MISC(str)
#endif

#define IO_MAP_REG	0x10
#define MEM_MAP_REG	0x14

#ifdef __FreeBSD__

static int   esp_pccard_init __P((struct pccard_devinfo *));
static void  esp_pccard_unload __P((struct pccard_devinfo *));
static int   esp_pccard_intr __P((struct pccard_devinfo *));

PCCARD_MODULE(esp, esp_pccard_init, esp_pccard_unload, esp_pccard_intr,
	      0, cam_imask);

static int  esp_pccard_find  __P((bus_space_tag_t, bus_space_handle_t,
				  struct esp_probe_data *));
static void esp_init __P((struct esp_pccard_softc *,
			  struct esp_probe_data *));
#endif

/*
 * Functions and the switch for the MI code.
 */
u_char	esp_pccard_read_reg __P((struct ncr53c9x_softc *, int));
void	esp_pccard_write_reg __P((struct ncr53c9x_softc *, int, u_char));
int	esp_pccard_dma_isintr __P((struct ncr53c9x_softc *));
void	esp_pccard_dma_reset __P((struct ncr53c9x_softc *));
int	esp_pccard_dma_intr __P((struct ncr53c9x_softc *));
int	esp_pccard_dma_setup __P((struct ncr53c9x_softc *, caddr_t *,
				  size_t *, int, size_t *));
void	esp_pccard_dma_go __P((struct ncr53c9x_softc *));
void	esp_pccard_dma_stop __P((struct ncr53c9x_softc *));
int	esp_pccard_dma_isactive __P((struct ncr53c9x_softc *));

struct ncr53c9x_glue esp_pccard_glue = {
	esp_pccard_read_reg,
	esp_pccard_write_reg,
	esp_pccard_dma_isintr,
	esp_pccard_dma_reset,
	esp_pccard_dma_intr,
	esp_pccard_dma_setup,
	esp_pccard_dma_go,
	esp_pccard_dma_stop,
	esp_pccard_dma_isactive,
	NULL,			/* gl_clear_latched_intr */
};

#ifdef __FreeBSD__

#define	ESP_PCCARD_IOSZ		0x10

static int
esp_pccard_init(struct pccard_devinfo *devi)
{
	int unit = devi->pd_unit;
	struct ncr53c9x_softc *esc =
		esp_alloc(unit, sizeof(struct esp_pccard_softc));
	struct esp_pccard_softc *sc = (struct esp_pccard_softc *) esc;
	struct esp_probe_data epd;

	ESP_TRACE(("[esp_pccard_init] "));

	if (sc == NULL)
		return ENODEV;
#if 0
	if (unit < esp_isa_unit_max)
		return ENXIO;
#endif
	if (sc->sc_enable)
		return ENXIO;

	sc->sc_enable = 1;
	sc->sc_iot = I386_BUS_SPACE_IO;
	sc->sc_ioh = devi->pd_iobase;

	/* probe */
	if (!esp_pccard_find(sc->sc_iot, sc->sc_ioh, &epd)) {
		esp_free(esc);
		return ENODEV;
	}

	esp_init(sc, &epd);
	printf("esp%d:%ssync,%sparity\n", unit,
	    epd.sc_sync ? " " : " no ", epd.sc_parity ? " " : " no ");

	/*
	 * Now try to attach all the sub-devices
	 */
	ncr53c9x_attach(esc);

	return 0;
}

static void
esp_pccard_unload(struct pccard_devinfo *devi)
{
	struct esp_pccard_softc *sc;
	int unit = devi->pd_unit;
	struct ncr53c9x_softc *esc;

	if (unit >= NESP)
		return;

	esc = esp_softcs[unit];
	sc = (struct esp_pccard_softc *) esc;
	sc->sc_enable = 0;

	ncr53c9x_detach(esc);
	printf("%s: unload\n", NCR_DEVNAME(esc));
}

static int
esp_pccard_intr(struct pccard_devinfo *devi)
{
	int unit = devi->pd_unit;
	struct ncr53c9x_softc *esc;

	esc = esp_softcs[unit];
	return ncr53c9x_intr(esc);
}
#endif /* __FreeBSD__ */

/*
 * Look for the board
 */
static int
esp_pccard_find(iot, ioh, epd)
	bus_space_tag_t iot;
	bus_space_handle_t ioh;
	struct esp_probe_data *epd;
{
	ESP_TRACE(("[esp_pccard_find] "));

	/* select register set #0 */
	bus_space_write_1(iot, ioh, NCR_CFG4,
		~NCRCFG4_CRS1 & bus_space_read_1(iot, ioh, NCR_CFG4));

	/* check command register */
	bus_space_write_1(iot, ioh, NCR_CMD, NCRCMD_NOP | NCRCMD_DMA);
	if (bus_space_read_1(iot, ioh, NCR_CMD) != (NCRCMD_NOP | NCRCMD_DMA))
	    return 0;

	bus_space_write_1(iot, ioh, NCR_CMD, NCRCMD_NOP);
	if (bus_space_read_1(iot, ioh, NCR_CMD) != NCRCMD_NOP)
	    return 0;

	/* XXX: probably we need new variant name "NCR53C500" */
	epd->sc_rev = NCR_VARIANT_ESP406;

	/* XXX */
	epd->sc_msize = 0;
	epd->sc_parity = 1;
	epd->sc_sync = 1;
	epd->sc_id = 7;
	epd->sc_irq = 0;

	/* select register set #0 */
	bus_space_write_1(iot, ioh, NCR_CFG4,
		~NCRCFG4_CRS1 & bus_space_read_1(iot, ioh, NCR_CFG4));

	/* Try to set NCRESPCFG3_FCLK, some FAS408's don't support
	 * NCRESPCFG3_FCLK even though it is documented.  A bad
	 * batch of chips perhaps?
	 */
	bus_space_write_1(iot, ioh, NCR_ESPCFG3,
	    bus_space_read_1(iot, ioh, NCR_ESPCFG3) | NCRESPCFG3_FCLK);
	epd->sc_isfast = bus_space_read_1(iot, ioh, NCR_ESPCFG3)
	    & NCRESPCFG3_FCLK;

	return 1;
}

static void
esp_init(esc, epd)
	struct esp_pccard_softc *esc;
	struct esp_probe_data *epd;
{
	struct ncr53c9x_softc *sc = &esc->sc_ncr53c9x;

	ESP_TRACE(("[esp_init] "));

	/*
	 * Set up the glue for MI code early; we use some of it here.
	 */
	sc->sc_glue = &esp_pccard_glue;

	sc->sc_rev = epd->sc_rev;
	sc->sc_id = epd->sc_id;

	/* If we could set NCRESPCFG3_FCLK earlier, we can really move */
	sc->sc_cfg3 = NCR_READ_REG(sc, NCR_ESPCFG3);
	if ((epd->sc_rev == NCR_VARIANT_FAS408) && epd->sc_isfast) {
		sc->sc_freq = 40;
		sc->sc_cfg3 |= NCRESPCFG3_FCLK;
	}
	else
		sc->sc_freq = 24;

	/* Setup the register defaults */
	sc->sc_cfg1 = sc->sc_id;
	if (epd->sc_parity)
		sc->sc_cfg1 |= NCRCFG1_PARENB;
	sc->sc_cfg2 = NCRCFG2_SCSI2;
	sc->sc_cfg3 |= NCRESPCFG3_IDM | NCRESPCFG3_FSCSI;

	/*
	 * This is the value used to start sync negotiations
	 * Note that the NCR register "SYNCTP" is programmed
	 * in "clocks per byte", and has a minimum value of 4.
	 * The SCSI period used in negotiation is one-fourth
	 * of the time (in nanoseconds) needed to transfer one byte.
	 * Since the chip's clock is given in MHz, we have the following
	 * formula: 4 * period = (1000 / freq) * 4
	 */
	if (epd->sc_sync)
	{
#ifdef DIAGNOSTIC
		printf("%s: sync requested, but not supported; will do async\n",
		       NCR_DEVNAME(sc));
#endif
		epd->sc_sync = 0;
	}

	sc->sc_minsync = 0;

	/* Really no limit, but since we want to fit into the TCR... */
	sc->sc_maxxfer = 64 * 1024;
}

/*
 * Glue functions.
 */
u_char
esp_pccard_read_reg(sc, reg)
	struct ncr53c9x_softc *sc;
	int reg;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;
	u_char v;

	v =  bus_space_read_1(esc->sc_iot, esc->sc_ioh, reg);

	ESP_REGS(("[esp_read_reg CRS%c 0x%02x=0x%02x] ",
	    (bus_space_read_1(esc->sc_iot, esc->sc_ioh, NCR_CFG4) &
	    NCRCFG4_CRS1) ? '1' : '0', reg, v));

	return v;
}

void
esp_pccard_write_reg(sc, reg, val)
	struct ncr53c9x_softc *sc;
	int reg;
	u_char val;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;
	u_char v = val;

	if (reg == NCR_CMD && v == (NCRCMD_TRANS|NCRCMD_DMA)) {
		v = NCRCMD_TRANS;
	}

	ESP_REGS(("[esp_write_reg CRS%c 0x%02x=0x%02x] ",
	    (bus_space_read_1(esc->sc_iot, esc->sc_ioh, NCR_CFG4) &
	    NCRCFG4_CRS1) ? '1' : '0', reg, v));

	bus_space_write_1(esc->sc_iot, esc->sc_ioh, reg, v);
}

int
esp_pccard_dma_isintr(sc)
	struct ncr53c9x_softc *sc;
{
	ESP_TRACE(("[esp_dma_isintr] "));

	return NCR_READ_REG(sc, NCR_STAT) & NCRSTAT_INT;
}

void
esp_pccard_dma_reset(sc)
	struct ncr53c9x_softc *sc;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;

	ESP_TRACE(("[esp_dma_reset] "));

	esc->sc_active = 0;
	esc->sc_tc = 0;
}

int
esp_pccard_dma_intr(sc)
	struct ncr53c9x_softc *sc;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;
	u_char	*p;
	u_int	espphase, espstat, espintr;
	int	cnt;

	ESP_TRACE(("[esp_dma_intr] "));

	if (esc->sc_active == 0) {
		printf("%s: dma_intr--inactive DMA\n", NCR_DEVNAME(sc));
		return -1;
	}
 
	if ((sc->sc_espintr & NCRINTR_BS) == 0) {
		esc->sc_active = 0;
		return 0;
	}

	cnt = *esc->sc_pdmalen;
	if (*esc->sc_pdmalen == 0) {
		printf("%s: data interrupt, but no count left\n",
		    NCR_DEVNAME(sc));
	}

	p = *esc->sc_dmaaddr;
	espphase = sc->sc_phase;
	espstat = (u_int) sc->sc_espstat;
	espintr = (u_int) sc->sc_espintr;
	do {
		if (esc->sc_datain) {
			*p++ = NCR_READ_REG(sc, NCR_FIFO);
			cnt--;
			if (espphase == DATA_IN_PHASE) {
				NCR_WRITE_REG(sc, NCR_CMD, NCRCMD_TRANS);
			} else {
				esc->sc_active = 0;
			}
	 	} else {
			if (   (espphase == DATA_OUT_PHASE)
			    || (espphase == MESSAGE_OUT_PHASE)) {
				NCR_WRITE_REG(sc, NCR_FIFO, *p++);
				cnt--;
				NCR_WRITE_REG(sc, NCR_CMD, NCRCMD_TRANS);
			} else {
				esc->sc_active = 0;
			}
		}

		if (esc->sc_active) {
			while (!(NCR_READ_REG(sc, NCR_STAT) & NCRSTAT_INT));
			espstat = NCR_READ_REG(sc, NCR_STAT);
			espintr = NCR_READ_REG(sc, NCR_INTR);
			espphase = (espintr & NCRINTR_DIS)
				    ? /* Disconnected */ BUSFREE_PHASE
				    : espstat & PHASE_MASK;
		}
	} while (esc->sc_active && (espintr & NCRINTR_BS));
	sc->sc_phase = espphase;
	sc->sc_espstat = (u_char) espstat;
	sc->sc_espintr = (u_char) espintr;
	*esc->sc_dmaaddr = p;
	*esc->sc_pdmalen = cnt;

	if (*esc->sc_pdmalen == 0) {
		esc->sc_tc = NCRSTAT_TC;
	}
	sc->sc_espstat |= esc->sc_tc;
	return 0;
}

int
esp_pccard_dma_setup(sc, addr, len, datain, dmasize)
	struct ncr53c9x_softc *sc;
	caddr_t *addr;
	size_t *len;
	int datain;
	size_t *dmasize;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;

	ESP_TRACE(("[esp_dma_setup] "));

	esc->sc_dmaaddr = addr;
	esc->sc_pdmalen = len;
	esc->sc_datain = datain;
	esc->sc_dmasize = *dmasize;
	esc->sc_tc = 0;

	return 0;
}

void
esp_pccard_dma_go(sc)
	struct ncr53c9x_softc *sc;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;

	ESP_TRACE(("[esp_dma_go] "));

	if (esc->sc_datain == 0) {
		NCR_WRITE_REG(sc, NCR_FIFO, **esc->sc_dmaaddr);
		(*esc->sc_pdmalen)--;
		(*esc->sc_dmaaddr)++;
	}

	esc->sc_active = 1;
}

void
esp_pccard_dma_stop(sc)
	struct ncr53c9x_softc *sc;
{
	ESP_TRACE(("[esp_dma_stop] "));
}

int
esp_pccard_dma_isactive(sc)
	struct ncr53c9x_softc *sc;
{
	struct esp_pccard_softc *esc = (struct esp_pccard_softc *)sc;

	ESP_TRACE(("[esp_dma_isactive] "));

	return esc->sc_active;
}

#define MAX_SCATTER (33)
#define MAX_SIZE  ((MAX_SCATTER-1) * (long) PAGE_SIZE)

#ifndef CAM
static void
esp_pccard_min_phys(bp)
	struct buf *bp;
{
	if ((unsigned long)bp->b_bcount > MAX_SIZE)
		bp->b_bcount = MAX_SIZE;
}

static u_int
esp_pccard_info(unit)
	int unit;
{
	return (1);
}
#endif /* !CAM */
